WP Photo Album Plus Changelog

= 8.0.08 =

* Improved smartness of caching. On changing photos, albums, adding comments and ratings etc., only the affected cachefiles will be cleared.
* Fixed film thumbnail titles.
* Calendars (non real) did no longer work. Fixed.
* Fixed erroneously stripped tags in descriptions.
* New settings Advanced settings -> System -> Items 41: Caching overrule and 42: Delay overrule.
To globally overrule the shortcode and widget settings.
There are 3 options: 1. do not overrule, 2. always as possible and 3. never.

= 8.0.07 =

* Security release. All querystring args are now processed and sanitized in one function wppa_get() in wppa-input.php
* Role specific upload limits did no longer work. Fixed.
* Popups on masonry thumbnails did not work when links on thumbnails differ from lightbox. Fixed.
* Rightclick on thumbnail or thumbnail popup allows you to open the link in a new tab, if No rightclick is not on.
* Title of the QR widget was wrong and not editable. Fixed.
* Linktypes 'The photos in the author(s) albums, slideshow' and 'All the authors photos, slideshow' for the BestOf widget/shortcode did not work. Fixed.
* Fixed issues caused by tags that contain single quotes.
* Custom datafields could only be updated by users that had unfiltered_html capability. Fixed.
* One can no longer cache the stats widget, its useless.
* Fixed a conflict with plugin Page Load Ajax.
* Added menu item Search. Opens a page with the green search bar like on the album table. Required capability is equal to that for Album Admin.
* If comments are disabled, the menu item to manage comments will no longer show up.
* Fixed various typos in texts.
* Frontend edit photo New style will automatically update the displayed name and description in the slideshow.

= 8.0.06 =

* New setting options to Basic settings -> Thumbnails -> II: Thumbnail display options -> Item 4: Thumbnail comcount.
Enables you to select a userrole, and show the number of comments given by userts with that role separately, only visible to users of that role.
* Pagination is now switched off when a photo enumeration is given.
* Fixed wrong links when photo names in urls is activated.
* In case of duplicate names in 'names in urls' they will not be converted to avoid confusion.
* When photo names in urls, slideshow always started at the first slide, also when a link expected a specific item. Fixed.
* Fix first found in cover image selection did not result in less db queries that was the objective of the feature. Fixed.

= 8.0.05 =

* New shortcode type: grid. New attribute photos. Typical use: [wppa type="grid" photos="1.2.5..19"] [wppa type="grid" album="5"] optionally size= and align=.
* New setting: Basic settings -> Links -> II: Links from standard images -> Item 8: Grid. Grid photo link.
* New setting: Basic settings -> Misc -> I: Miscellaneous settings -> Item 9: Grid video controls. Show the video controms on a video in a grid display.
* New setting: Basic settings -> Search -> I: Search albums and photos features related settings -> Item 35: Show empty search.	Display empty search message.
* Fixed a fatal error on the Album admin pages, that happened only when not admin and photo order restricted.
* Basic settings -> Misc -> I -> Item 3: Default coverphoto selection, has an extra checkbox named Fix first found. This shows only when a random methid is selected.
When checked, the first found will be registered as fixed cover image. The Reset all checkbox enables you to reset all the fixed coverimages.
* Dropped the selection item Compressed for pretty links as it often does not work correctly.
* Filmstrip layout was wrong when the size arg was used in the shortcode. Fixed.
* WPPA now uses wp-jquery-ui-dialog css file, and code has been changed to be compatible with it, to avoid conflicts with other plugins that use it also.

= 8.0.04 =

* Settings page will no longer crash when the php implementation does not support the exec() command.
* Fixed inconsistent behaviour of 'slideshow wrap around' feature.
* Improved behaviour of popup thumbnails. They come up now correctly.
* New setting: Basic settings -> Slideshow -> IV -> Item 14: Easing formula.
* New setting: Basic settings -> Lightbox -> I -> Item 28: Easing formula.
* New setting: Basic settings -> Thumbnails -> III -> Item 9: Popup easing formula.
* You can now combine thumbnail popups with all available thumbnail links, so also lightbox.
* Albums now have a status. Publish is the default, Private: only visible to loggedin visitors, Hidden: only visible to admin and superusers.
* Mailing unsubscribe links failed. Fixed.
* Improved algorithm to clear non-wppa caches.
* Corrected and extended helptext in titles (balloons) on the Album Admin -> Edit Album Information page.
* Hotfix 8.0.04.007: Current values of input and selections did not show up on the settings page. Fixed.

= 8.0.03 =

* Extended alternate ajax methods and fixed certain links.
If frontend ajax links do not work, you can select different ajax methods on Advanced settings -> System -> I Item 5: Ajax method. ('Normal' is default).
Classic is like pre ver 8 method 'Ajax non admin' ticked, Backend method is like pre ver 8 'Ajax non admin' unticked (uses admin-ajax).
* If frontend upload does not work (give errors) set Advanced settings -> Users -> I Item 5.1: Upload Ajax method to 'extern' (like classic) or to 'backend' (uses admin-ajax). ('normal' is default).
* Note on upload. If you want users to upload to sites that have a site password, i.e. where users do not need to login with their name, treat them as non logged in.
To allow uploads in this case: tick the box in Advanced settings -> Users -> I Item 32: Upload logout, and make sure the owners of the albums allowed to upload to are set to ---public---.
* If you do not use the widget or the upload shortcode but let them upload using the album cover link, make sure empty albums are not skipped, to allow the first upload.
See Basic settings -> Albums -> II Item 7: Skip empty albums.
* Plugin All in One SEO tampers the internal wppa occurrance counters because it renders the page before the actual page building.
This results in certain links not working like the link from an image in a widget to a landing page, because the landing shortcode is no longer the first occurrance.
Provided a fix for this by resetting the counters at the end of the the process that builds the page header.
* When both defer javascript was active and the shortcode was cached, reponsiveness was no longer fully supported. Fixed.
* Switching off manual control on a spheric panorama caused a js error resulting in not displaying the image. Fixed.
* The documentation site https://wppa.nl now shows the version 8 settings.
* Fixed a problem in scheduled renewing crypts. The time interval is now correctly obeyed.
* Cache is now cleared when a maintenance procedure has completed.

= 8.0.02 =

* Further restructured javascript loading and inits. One can now also cache slideshows and slideshow widgets when defer javascript is on.
* Re-added the feature that non loggedin users can upload photos. Be careful wit this, especially make sure moderating is on.
See Advanced settings -> Users -> I Item 32: Upload logout, and Advanced settings -> Admin -> II Item 11: Upload moderation.
Added an admin notice about this if applicable.
* Fixed frontend upload issues.
* Added option Advanced settings -> System -> I Item 5: Ajax method.
In vertsion 8 the official way to use Ajax at the frontend as documented in the Developers manual was implemented.
Unfortunately this method appears not to work on every site, so i added a selectionbox with 4 options.
If certain links at the frontend do not work, try one of the alternate methods.
If frontend upload does not work properly when the progressbar (i.e. ajax upload) is on,
try one of the alternate methods listed in Advanced settings -> Users -> I: Item 5.1: Upload Ajax method

= 8.0.01 =

* Re-added the WPPA+ text widget for backward compatibility.
* All querystring items now have a value. This fixes the fact that isset() returns false when the value is null, leading to certain links not working proprtly.
* Improved algorithm for lazy load on mobile devices.

= 8.0.00 =

* Restructured and greatly simplified settings page. Removed obsolete and redundant settings. Made the layout more friendly.
* Photo of the day admin page is now in the Settings page under Photos.
* To create albums or upload photos can only be done by logged in users, you can no longer configure these features for loggedout visitors.
* Custom css settings are being fased out. One is encouraged to move that to the wp customizer.
On the settings page you will only see the custom css items that are not empty. The help text encourages you to move the content to the wp customizer.
* Ajax method changed. No longer possible to choose between admin or non admin ajax.
Ajax is always activated, because there can no longer be conflicts due to inaccessibility of both ajax files from the frontend by http request.
* Photo count treshold has been removed because one can select a childrens image as cover image of any album.
* Nice scroller is no longer loaded on mobile devives. Scrollbars on mobile are nice enough by themselves and this improves performance.
* Removed WPPA+ Text widget. You can now use the WP Custom HTML widget instead.
* HTML in descriptions is now automatically allowed for those users who have HTML edit rights.
* Widgets do no longer show up anywhere if the corresponding feature is not enabled. e.g. Notify widget - Enable email. etc.
* The shortcode to display the most recently uploaded photo did not work when additionally the album was specified e.g.
[wppa type="photo" photo="#last,12"] or [wppa type="photo" album="12" photo="#last"]. Fixed. Works also for type="mphoto" and type="xphoto".
* Fixed a slideshow filmstrip layout issue for theme twentytwentyone.
* The max simultaneous ajax requests during resequencing photos is now limited to 10. This prevents db errors due to too many open db instances.
* Caching system is simplified. Just on or off. In widgets: checkbox; in shortcodes: '', '0', 'off' or 'no' means no caching; anything else means caching on.
Although the fact that there are separate cachefiles for logged-in and logged-out visitors, make sure you do nat cache widgets or shortcodes that may display user dependant content.

= 7.7.07 =

* Shortcode virtual album attribute album="#related,... did not work. Fixed.
* Client side performance improvements.
* New feature: If panorama is enabled (Table IV-A24.2), one can now bulk set all the photos of an album to a valid panorama mode for those .jpg photos that have their x/y ratio >= 2.
* New setting: Table IV-H5: Panorama max width spheric. The max size when a spheric panorama is converted to 360° can now be set from 4.000 up to 10.000. Was 6.000 previously.
If set to spheric, the files will be converted to get the right aspect ratio if required, i.e. the source image will be padded so the height will be half the width.
* Converting spheric panoramas to cover 360&deg; now uses the jpg image quality as set in Table IX-A2.

= 7.7.06 =

* Lazy load now also works on single images, and is faster and more reliable.
* Fixed compatibility issues with other plugins.
* Setting status to featured did not copy the photo to the wp media library when activated from the frontend. Fixed.
* Undeleting an item caused the creation of an album even when when there was no reason to. Fixed.

= 7.7.05 =

* The 'You can see the photo here' link on moderate comment request mailings did not work. Fixed.
* The logfile admin page will now be updated every 5 seconds.
* On the Album Admin -> Edit album information page you can now schedule a time to delete an album.
When this time arrives, the album will be removed and the photos will be trashed and permanently removed in a background process after at least one hour.
* When a deleted photo is being undeleted and the original album has been removed, the album will be re-created with default settings and with parent set to ---separate---

= 7.7.04 =

* Fixed various non fatal PHP warnigs.
* Improved algorithm to prevent duplicate mails.
* New Setting: Table IX-K7: Image Magick cropping. You can now select default aspect for cropping when ImageMagick is on board.

= 7.7.03 =

* On the dashboard widget 'Recent wppa activity' the authors of comments were all Nomen Nescio. Fixed.
* Disable rightclick did not work on zoomable, panorama and lightbox. Fixed.
* Description did not show up on sidebar slideshows when activated. Fixed.
* If rating is set to one button vote, the number of votes will show up under the thumbnails rather than the average value.
* After successfully applying a watermark, the admin page will be now reloaded to show the changes.
* Fixed a layout issue on audio controls on thumbnails and single images.
* Table IV-B11: Run nl2br or wpautop on description now also works on single photos with description.
* Re-uploading an image file with audio did not replace the source file. Fixed.
* Re-uploading an image file that had been modified by imagick did not replace the source file. Fixed.
* New setting: Table IX-B15.0: Use audiostub. You can now switch off the use of an audio stub image.
* New settings: Table IX-M20 and 21. You can now set the sitename and the from email address to be used in emails sent by wppa.
* Overruling the displayability of name, description, rating and comments on album basis did not work on thumbnail popups. Fixed.
* If the php version does not support ttf fonts, the use of textual watermarks will be disabled and no longer crash the settings page.

= 7.7.02 =

* New setting: Table II-E10: Album id on cover. Places the album id in parenthesis near the album name on album covers. Selectable: 'none' (default), 'If user has edit access', 'Always'.
* New setting: Table VI-C14: Album id on cover is link. The album number on the cover links to the album admin page of the album for those users who have the rights to edit the album info.
* On the Album Admin page you can now also enter an album id to edit the album directly without the need to locate the album in the albumtable.
* Overruling display options as introduced in 7.7.01 not always worked correctly. Fixed.
* When the number of frontend uploads was set independant of albums, frontend upload did not took into account that a deleted photo may be replaced by a different one. Fixed.
* New setting: Table IV-E21: Contest comment visibility. The policy to display comments on the contest display.
Possible options are: 'None', 'Commenter', 'Commenter and photo owner', 'Every visitor'. Note: Admin always sees the comments.
* On the album admin page one can now specify a max upload per user for the entire tree of albums below the current album (inclusive).
This upload limit superseeds all other frontend upload limits.

= 7.7.01 =

* New feature: On the album admin page (Edit album information) one can now overrule the following default settings for the items in the album:
display name, description, rating and comments. You can select default to use the systemwide setting, yes to display or no to hide the attribute regardless of the systemwide setting.
This works for slideshows, thumbnails and lightbox, where applicable.
* Fixes: Slideshow animation type swipe only worked for next slide but did not wor for previous slide. Fixed.
* Removed obsolete css attribute enable-background on svg elements and missing colors for svg tags are now replaced by transparent.
* The album admin page (Edit album information) now also has a button to download the album (zipfile of the images). Works like the download link on album covers.
Note that Table VI-C2: Album download link must be ticked. If you want this feature only for admins, make it a restricted action in Table VII-C11.
* When 'adding owner to name' was activated in Table II-B5.1 and/or Table II-D2, the name of the photo was displayed even when displaying name was off (Table II-B5 and Table II-D1).
This has been corrected; the photo names will now be hidden in that case.
* The state of the 'remove empty dirs' switch on the import screen is now saved in a technical cookie and is no longer always on.
* New shortcode type type="contest". Displays the rating results of an album. Syntax: [wppa type="contest" album="<album id>"] The album id may be either a single id or an enumeration.
Alternatively you can supply attribute parent="<parent id>" where parent id may be a single id or an enumeration of album ids.
* New setting: Table IV-E18: Contest top creterium. You can select 'Mean rating' (default) or 'Total ratring'.
* New setting: Table IV-E19: Contest number. You can select '---none---' (default), 'Photo id' or 'Sequence number' to be placed near the photo name under the preview image.

= 7.6.10 =

* Childlist cache did not got updated when a 'granted' album was created. Fixed.
* Fixed childlist for certain album ids.
* New setting: Table IX-A19: CSV file separator. You can now select ; vs , for csv import and export.
* Overall performance improvement.
* New setting: Table VII-C11: Album download link restricted. Restricts the album download link on covers (Table VI-C2) to admin and superusers.

= 7.6.09 =

* Childlist cache did not got updated when a new top-level album was created. Fixed.
* Fixed a js error on admin pages.

= 7.6.08 =

* Fixed a compatibility issue with Ultimate Member when Lightbox global is active, resulting in uploading in UM no longer works.
* Performance improvement lightbox, spheric panorama and lazy load.
* You can now use deferred javascript (Table IV-A13) when there are zoomable and/or panoramic images on the page.
* Fixed missing default photo description during upload.

= 7.6.07 =

* Speeded up by caching the list of sub(sub...)albums of any album.
This reduces the number of db queries in certain circumstances e.g. when the coverimage selection method is set to random or most recent from subalbums.
* The new photo description as defined in Table IX-D5 is now applied to all media types, if not overruled by the user and required by Table IX-D3.
* Fixed a layout issue in masonry thumbnails while using Tabby.
* The number of colums on mobile devices when thumbnail type is Masonry Columns is now half the number on pc.
* Fixed permalinks for pdf posterfiles.
* Fixed incidently missing lazy loading.
* Fixed remaking display files for pdfs with imagick.
* Setting the status of a pdf to featured will now copy the pdf to the wp media, like photos and videos already do.
* Photo names of pdf files are now diaplayed standard - as defined in Table IX-D13 - or as manually edited afterwards.

= 7.6.06 =

* Fixed Cloudinary interface.
* Fixed security issues.

= 7.6.05 =

* Changes for compatibility with PHP 8
* Changes for compatibility with plugin Tabby
* Portrait only sidebar slideshows stopped working. Fixed.
* New shortcode type: [wppa type="lastupdate"] with optional attribute album="id", where id is the album id.
Prints the timestamp of the most recently uploaded item in the supplied album, or systemwide in the format as specified on the wp general settings page.

= 7.6.04 =

* Fixed layout and behaviour issues in lightbox on panoramic images.
* Improved detection of slideshows outside viewport for suspending them.
* Fixed a php error in the error handling during upload.

= 7.6.03 =

* Table I-A11: Sticky header size can now be set up to 400.
* Table IV-A38: Fullscreem policy set to 'On lightbox only' stopped working. Fixed.
* A running slideshow will be suspended until any part of the present elements (slideframe and/or filmstrip) is inside the viewport.
* You can now filter the album table by a searcheable token from the album index.
* New setting Table VI-A1.1a: Art Monkey new filetypes. Select filetypes to be downloadable when Table VI-C1 is set to New style. You can select Photos, Pdfs or both.

= 7.6.02 =

* The Import page now has buttons to link to the Edit Album page near the album selection boxes to edit the just imported items.
* Added $args = apply_filters( 'wppa_photo_entry', $args ); to function wppa_create_photo_entry( $args ); to be able to modify the photo data at the time of creating the db entry.
* New setting: Table IV-A1.4, Non Ajax scroll. Acts like Table IV-A1.3 but for non ajax links.
Note: To compensate for a sticky header, set Table I-A11 to an appropriate value; this works for both IV-A1.3 and IV-A1.4.

= 7.6.01 =

* New setting: Table VI-C13: Moderate links admin/superuser/owner only.
If ticked, the moderate links etc. on the frontend will only be shown to admins, superusers and the photo owners.
The owners still need to have the capability moderate in Table VII-A.
* Fixed links to the wp plugins page when 'gallery not album' is activated in Table IV-A36.
* New setting Table IX-D11.4: Grant restrict. Only create albums for users with Album Admin rights, See Table VII-A, first column. They need no upload rigts.
* New setting Table IV-A27.3: Admins Choice action. You can now select the action for Admins Choice. Either add to personal zip (default), copy to grant album if available or both.
In case of album only, the links are only shown to users who have album admin rights.
* Non admins/superusers can only delete their own photos and albums.
* New setting Table VII-C10: Album Admin separate. Restrict album admin to separate albums for non administrators.
* Copying photos from one album to another did not update them in cdn cloudinary. Fixed.
* Fixes for compatibility with wp 5.6
* You can now also enter filenames and photonames in the green search field on the Album Admin page.
* Thumbnails of panorama images now always use the thumbnail file rather than a possible CDN file for display.
* Creating thumbnails for 360 spheric panoramas now always use the original, i.e. not the possibly formatted source file.
* New setting: Table IV-H4:	Initial zoom spheric panorama.

= 7.5.10 =

* Searching on numbers on the album admin screen now also returns real search results besides the already implemented list of ids.
* Slideshow filmstrips now aways use the thumbnail files, regardless of selected aspect ratio or cdn service.
* Extended options for slidehow animation time in Table IV-B6.
* Fixed a imagick command that could cause unwanted padding in thumbnail creation.
* The availebility of ImagMagick is now detected and activated automatically on opening the settings page the first time after install/update if it was not already done manually.
* New setting Table I-F15: Character sizing.
You can specify 'linear' (default), 'quadratic' or 'cubic' for the formula that determines the relation between the number of items and the size of the tagcloud text.
* Fixed shortcode generators. They all work back properly now, both on classic as on block editor in classic blocks as well as the wppa custom block types.
* Fixed some php warnings.

= 7.5.09 =

* On zoomable images: since panning by touch now works, swipe has been removed.
* Spheric panoramas on fullscreen lightbox now cover the entire screen; performsnce improved.

= 7.5.08 =

* Fixed pre-loading in lightbox and corrected previous image selection.
* Made zoomable image code more stable and faster.
* Custom datafields were no longer qTranslate style translated. Fixed.

= 7.5.07 =

* Fixed a layout issue in lightbox.
* Fixed a compatibility issue with search plugins.
* Fullscreen lightbox will now initially display the zoomable image screen-filling with the capability of zooming out.
* Pertformance improvement for zoomable images.
* Fixed a problem in calculating related data causing db errors.
* Registering failed mails for retrying did not work. Fixed.
* Table IX-A10: Retry failed mails has been moved to Table IX-M100.

= 7.5.06 =

* Increased z-indexes fopr lightbox.
* Zoomable non-panorama images were always erroneously displayed with aspect ratio 2, except in lightbox. Fixed.
* Clicking on the background in lightbox did not always work as configured, especially at the left side of the image. Fixed.
* New setting Table IX-E24: Use wppa search form. Tick this box when other plugins break the wppa search function.

= 7.5.05 =

* Lightbox now works in normal mode only on iPad and Safari.
* When fullscreen policy is set to the entire page, this will now also work when javascript is deferred and there is no wppa activity on the page.
* Added .jpeg as remote importable filetype.
* New virtual album type #potdhis. Dispplays the photos that are stored in the photo of the day history.

= 7.5.04 =

* New setting: Table IV-A38: For enabling fullscreen buttons: You can select none, for lightbox only or for the entire page. The colors can be set in Table III-B16.
* Fixed a 404 on a js file in admin pages.
* Fixed a db error when Exclude separate was active while there were no seperate albums.
* Improved stability in lightbox displays.

= 7.5.03 =

* Performance improvements, especially in extended duplicate removal and skip separates in photo search and tag search operations.
To reduce http requests, there is now a combined compressed js file.
* Now uses wp supplied jquery-masonry library rather than the one in the vendor subfolder wich has been removed.
* Restored admin spinner that had been erroneously removed.
* Table IX-E2: Exclude separate, now also applies to search by tag(s).
* Some browsers do not accept entering fullscreen mode programmatically when not invoked by a direct user action like clicking a link or a button.
To overcome these problems, and because some users asked me to restore the ability to run lightbox on mobile in normal mode, lightbox will now always start in normal mode, both on pc and on mobile.
Both versions will have the fullscreen button to switch to fulscreen (and back) if desired.

= 7.5.02 =

* Lightbox enhancements.
All navigation buttons are now below the image.
Mobile devices always run in fullscreen mode.
The only fullscreen mode is padded.
Switching to and from fullscreen works now properly also on mobile devices.
Swipe left/right works on all zoomable lightbox types on mobile devices.
Fixed GPU overload on initial display of zoomable images.

= 7.5.01 =

* Fixes to comply with WP 5.5.

= 7.4.03 =

* Running and browsing through paginated slideshows will now automaically continue on the next c.q. first page after the last slide on the current page.
* You can now overrule the default setting zoomable (Table IV-A37) on the album admin page for that specific album.
* Remaking files no longer creates unwanted files in the source folders.
* Added log messages when a mailing is not run because it is disabled or it has no subscribers.

= 7.4.02 =

* Missing IPTC or EXIF data will no longer be displayed as N.a., but will show empty.
* The parent shortcode attribute will now also work for virtual albums. E.g. [wppa type="content" parent="#featen,1,5"].
* Shortcode type="url" did no longer work due to concatenated html comment. Fixed.
* New setting: Table IV-A37: Enable zooming. Enables zooming and panning on non-panorama images the same way as panoramas work.
Note: Like panoramas, also zooming does not work in slideshows and in lightbox when linked from slideshows.
* New setting: Table IX-B21: The max number of photos in the selectionbox in the shortcode generators is now selectable.
* You should no longer receive duplicate emails.

= 7.4.01 =

* New setting Table IV-A35.1: Request info dialog text. Requesting info now opens a dialog box that asks the user to specify his request.
* New setting Table IV-A36: Use Gallery not Album. Changes all 'album' into 'gallery' in all texts.
* New setting Table IV-A27.2: Admins choice me only. Shows the link to the current users zipfile only.
* New shortcode attribute login="yes" or login="admin".
The wppa shortcode is only processed when the user is logged in or the user is and admin or wppa superuser.
* Runtime modifyable settings now also work on ajax links generated when the settings were active.
This means that a shortcode with the delay attribute inside a [wppa_set] wrapper now also obeys the runtme modifyable settings.
* Shortcode types that result in unexpected display when attribute delay is used
now produce a log debug message and will ignore the delay attribute rather than a generic album display.
* Table VI-C1 (download link) has a new option: new.
Creates a download button for loggedin visitors only, on the same row as the edit/delete/request info/My choice buttons. Photos only.
* There are now distinguished cachefiles for logged-in and logged-out visitor displays.

= 7.4.00 =

* Various security fixes.
* The nesting level on the album admin page will now only show up when you use the max level limitation in Table VII-B1.0, i.e. the value <> 99.
* You can now add some exif/iptc tags as default for the photo custom datafields.
They will be filled in with the corresponding data at upload/import if available.
For backward compatibility, Table VII-B4,2: Apply New Photodesc, will also fill in the data for existing items if available.
When there is no value for an w#cd-keyword, an 2#-iptc item or a E#-exif item,
the corresponding label value will also be empty when the photo description is filtered for keywords.
This means that a table line like e.g.
<tr><td>w#cc0</td><td>w#cd0</td></tr> will show nothing as long as there is no css that forces the height of it to be > 0.
* Added chackbox to Table IX-D5 to autmatically remove linebreaks and redundant space when new the photo description is updated.
* New setting: Table IX-D11.4: Iptc 025 keywords to tags. Convert IPTC025 keywords to tags during upload. Saving IPTC must be on.
* New maintenance proc Table VIII-B24: Re-init custom and tags.
* The album table was not switcheable to Collapsable table for non admin users when 'owners only' is active. Fixed.
* Table IX-E21: Extended duplicate removal, now also works on calendars.
* Table IV-A27: Enable Admins choice, is now a selectionbox. You can select 'none', 'admin and superuser' and 'all loggedin'.
So the meaning of 'Admins Choice' can now be extended to 'Users Choice'.
* You can now remove items from the MyChoice zipfile.
* New setting: Table IX-A35. Enable request info. Shows a button under the slideshow image to request info by email.
* New setting: Table IV-A27.1. Tag admins choice. The user who selected MyChoice will add the tag User-<userid> to the item.
This means that e.g. a slideshow can be generated with the seleced photos:
[wppa type="slide" album="#tags,User-1"] for admin or [wppa type="slide" album="#tags,#me"] for the current user.
* When the download link is text and not the source, a download dialog will appear rather than the image in a new window.

= 7.3.12 =

* The cursor on album cover images where cover type is imagefactory(-mcr) and the link is lightbox,
does not change from wait to magnifier when the initialisation of lightbox is complete. Fixed.
* Changes to the cover image selection method: Added 'according to photo sequence'
to the album cover image selection on the album admin and on the settings page;
Added '--- default --- See Table IV-D2' to the cover image selection box on the album admin page.
These changes make it simpler to change the selection method for all -default- albums at once,
provided that the settings on the album admin pages are set to the default, previously being random.
* The album and parent attributes in the wppa shortcodes with type="acount" and type="pcount" can now also be an album enumeration.
* Added class wppa-thumbarea-albdesc for album description on thmbnail area.
* If there is no posterfile for a pdf, there will now be a dummy image as thumbnail, derived from ../uploads/wppa/documentstub.png.
* When the status of a photo is private, it will no longer show up in the topten widget for users not being logged in.
In this case one should not cache the widget.
* If Table IX-D19 and IX-D20 are both unticked, there will now also be no check for utf-8 encoding on filenames during upload/import.

= 7.3.11 =

* New thumnail types: 1. Masonry style plus. See Table IV-C3. Make sure your thumbnail size equals the thumnail framesize (Table I-C1 and 3).
This type is like masonry style vertical, but is fully mobile friendly.
2. Masonry style mix. Uses Masonry style vert on pc and plus on mobile. Best of two worlds.
* Some minor fixes.
* New setting: Table VII-B1.0: Max nesting level. Limits the ability to create subalbums at the frontend to the indicated level.
The album nesting level is displayed in parenthesis on the album admin page next to the id.

= 7.3.10 =

* The behaviour of lazy load on filmstrips has been improved.
* Fixed a typo resulting in an error in a cron process.
* New setting: Table IX-D21: Default photo status. Can be set to 'publish' (default), 'pending', 'featured' or 'private'.
Note that this setting does not overrule the settings in Table VII-B7.0: Upload moderation and Table VII-B7.1: FE Upload private.

= 7.3.09 =

* Fixed a possible layout issue in the album navigator when caching was on for this widget.
* New setting Table IX-A18: Add locale. Always add locale to links. You may need this setting if you use a multilanguage plugin not being qTranslate.
* The linkpages for the tagcloud and multitag widgets/boxes have been extended with --- the same page ---.
Usefull when using multilanguage plugins not being qTranslate and intented for the box.
The behaviour for a widget depends of the specific page layout and is therefor unpredictable.
* Various cosmetic changes.
* When remake add is ticked (Table IX-H6) a duplicate photo item for a videao was created
when the button 'Remake all' was ticked on the album admin page. Fixed.
* Reverted mod from 7.3.03: 'Fixed duplicate ids in search code for certain themes.' because it caused layout issues.
* The subdir 'dynamic' is now also created at plugin activation.
* Added option 'basic' to the Membership selectionbox in Table VII-A. This effectively limits the capabilities of users.
A 'basic' member can not create/delete (sub)albums, upload, delete possibly existing own photos, enter comments and rate photos.
Setting this for an administrator or a superuser has no effect.

= 7.3.08 =

* New feature: Setting Table IX-A17: Translate. Translate names, descriptions and other text using qTranslate rules without a language plugin.
* Geo did not work when encrypted links was enabled. Fixed.
* Labels of custom fields are now translated on the album/photo admin screen.
* Breadcrumbs are now fully translated.
* Tagcloud and Multitag is now alphabetically even with translatable items.
* You can now cache widgets and wppa boxes on a multilingual site.
* Changed htmlentities() into htmlspecialchars() in many places to prevent accented characters to be displayed wrong: e.g. Ã¶Ã¤Ã¼ instead of öäü.

= 7.3.07 =

* Scheduling of individual images did not work. Fixed.
* Premium indicator was also displayed in a photo description when the description contained any keyword but no user name was required. Fixed.
* New setting: Table IX-D15.2: Copy Custom. When ticked, will copy the contents of the custom datafields on copying photo.
* Improved behaviour of lazy load. Sometimes at the end of scrolling a few images were not shown until the next scroll or resize event. This has been fixed.
* Removed hardcoded background color of comments. You can set a bg color as custom css: .wppa-comment-bquote { background-color: <valid css color> !important; }
* When a wppa container was shifted out of the viewport, it was set to hidden. This has been removed to improve user experience.

= 7.3.06 =

* Table VI-C8: Album navigator Link has been moved to Table VI-A3.1 and the options are extended.
* To Table VI-C11: Album cover subalbums link, added option "Subalbum title link". This also supports the otpion "the link page with a clean url" when set on the album admin page.
* Added cache and delay checkboxes to shortcode generators.
* Wppa cache is now also automatically cleard when a page or post is saved that contains a wppa shortcode.
* Fixed a layout issue when Table IX-L3 (size of [photo] shortcode photo) was set to a fraction i.e. a positive value < 1.0;
* Shortcode type="acount" and type="pcount" did no longer work with argument parent. Fixed.

= 7.3.05 =

* Caching shortcode [photo ...] did not work. Fixed.
* The premium user indicator is now also displayed near the owner of the photo when added to the photo name in Table II-B5.1: Add (Owner).
* After stop-start filmonly continuous, it lost animation. Fixed.
* Fixed a warning about $_ENV['REQUEST_URI].
* Fixed a lay-out issue in selectrionboxes on wppa admin pages.
* New setting: Table IV-A1.3: Ajax scroll. You can now switch off scrolling the page after ajax updated the page content.
* Shortcode arg delay="yes" did not work. Now it does work and it has more options. It is still under development; not all shortcode types/albums will work.
There are four forms e.g.: delay="yes", delay="Yes,nnn" where nnn is delaytime in millisec, delay="button,Buttontext" and delay="text,Linktext" to produce a button or a textlink.
* Frontend upload videos failed due to missing function. Fixed.
* The animation for 360 panoramas was much slower on mobile devices than on pc. Fixed.
* Fast starting/stopping slideshows may cause instability. Fixed.
* You can now have both delay and cache attributes in the same shortcode.

= 7.3.04 =

* Fixed a conflict with cached sidebar slideshows.
* New feature: You can assign gold, silver, bronze or plus level of premium usership to any user role. Table VII-A.
The corresponding medals are shown together with the user display names in photo descriptions and comments.
* The photo of the day changed most of the times when a new photo is uploaded, and the policy is: change every hour ... month. Fixed.

= 7.3.03 =

* Fixed a resizing issue when using nicescroller.
* De-activated tinymce mode in wp editor on album and photo admin, due to unfixed problem in wp_editor() or tinymce.
* Fixed duplicate ids in search code for certain themes.
* Fixed a performance issue on the settings page for systems with many users.
* Fixed the excessively creation of widget landing pages.
* You can now also select POSTS as the album title link on the album admin page.
* New checkbox: Table VI-A3: ASO. Album Specific Overrule.
If you tick the ASO box, the album title link settings overrule the default album widget link type and page settings,
but only when the album link page or post is not set to --- the same page or post ---
* You can now edit iptc data on the Photo Albums -> Album Admin -> Edit Manage photos screen. The metadata in the database is updated, the source file us untouched.
* Fixed several php warnings that show up at php version 7.4

= 7.3.02 =

* New setting: Table IX-A11.1: Show minimum tags only. Shows only the tags defined in Table IX-A11 in the selection box on the photo admin page.
Note that it is recommended to tick Table VII-C9: New tags restricted, if you want to prevent the creation of new tags by non-adminstrators.
* New feature: Smartt caching.
1. The widgets have an extra option on the activation screen to enable caching of the widget content.
The cache expiration time can be selected between 5 and 60 minutes at widget activation.
The widgets QR, Notify, Stereo, Admins choice have no caching option because it is unwanted or useless.
2. Shortcode caching. All wppa shortcodes except type="landing" can have an extra attribumte: cache="".
The value betweeen the double quotes may be a number between 5 and 60, meaning the expiration time of the cache file.
Both types of cache files will be 'smart' cleared prior to the expiration time when needed.
On top of this, the Photo Albums admin menu has an extra option to clear all wppa cache instantaneously.
* New setting: Table IX-A9.7: Log Timings. Logs a.o. widget genberation times and no of queries.
* The default state of all checkboxes in widget activation dialogs is now unchecked.

= 7.3.01 =

* New setting: Table II-B1.2 Renew on Filmonly. Adds a renew link to the start/stop navigationbar on the slideonly display. Requires Table II-B1.1 (Start/Stop on filmonly) and Table IV-A1.0 (use Ajax) being checked.
* New setting: Table II-B18 No animate on mobile. If ticked, slideshow does no animation on mobile devices to unload cpu.
* Improved positioning and animations of filmonly deisplay.
* No longer uses https://cdnjs.cloudflare.com/ajax/libs/jquery.nicescroll/3.7.6/jquery.nicescroll.min.js due to bug https://github.com/inuyaksa/jquery.nicescroll/issues/799.
Now uses .../wp-photo-album-plus/vendor/nicescroll/jquery.nicescroll.min.js that has been patched.
* Removed slideshw animation types that do not work properly. Remaining types are: fadeover (default), fadeafter and swipe.
* Fixed a not defined PHP warning.
* Fixed a fatal error in import proc.

= 7.3.00 =

* The originators of ratings and comments are now defined by their user ID if they are loggedin, and by their IP addresses when they are not logged in.
This fixes contaminations when users change their display name and in case of non unique display names.
* Default settings are no longer stored in the wp_options db table. If a setting is set to the default value, it will be removed from the db and the deafult value will be used instead.
If an update comes with a changed default value, and the setting had been set to the old default value, the setting will get the new default value. Changed default values will always be listed in the changelog.
* Januari as next month on the real calendar was not recognized as being in the future. Fixed.
* To speed up dynamic behaviour, redundant execution of responsive resize handler code will now be prevented as much as possible.
* Added horizrailenabled:false to the default nicescroller options.
* New setting: Table IV-B17: Filmonly random. If ticked, every pageload the sequence of the filmonly images will be different.
* The initial position of the filmstrip is not animated even when the filmstrip animation is activated.

= 7.2.16 =

* The horizon on the photo admin page is now up/down draggable. Note: Imagick must be activated to adjust photos to the horizon.
* New setting: Table IV-B16: Filmonly continu. The filmstrip will move almost continously. The speed is approx the animation time per item. Make sure the speed is not set to --- off ---.
* New setting: Table II-B1.1: Start/stop on Filmonly.
* Lightbox on filmstrip now never uses thumbnail images.
* Fixed a lay-out issue on theme twentytwenty for lightbox panoramic images where the controls did not align and on filmstrips.
* The filmstrip now looks to continue on a running slideshow between last and first image without jumping back.
* Table IV-B12 now also works on xphoto.

= 7.2.15 =

* The initial display width in cases where the shortcode specifies a maximum responsive size like size="auto,550" is now correctly set to 550 as opposed to the value in Table I-A1.1.
* On all places where the shortcode [wppa ...] accepts the arg album=".." you can ow also enter parent="..".
The parent attribute overrules a possible album attribute.
The parent attribute may be an enumeration of parent ids.
Note that parent="0" means: all non separate albums, and parent="-1" means: all separate albums.
* The most recent status of the 'opened' lists of subalbums of the album table on the album admin page is now remembered like the open tables of the settings page.
* New setting: Table IX-E23. In case of conflicts you can set the form method for search to 'get' as opposed to 'post'.

= 7.2.14 =

* You can now enter a name for your backup of the settings; this means you can now have multiple backups without the need to ftp them to your local pc and rename them.
* Settings backup files are no longer removed from the depot when the user enters the import adnmin screen.
* Real calendar days with items now also show the daynumber; Improved (initial) display.
* Real calendar now also displayes properly in static (non responsive) environments.
* When the real calendar links to slideshow, partially wrong images were displayed in the slideshow. Fixed.
* Added 5:8 as selectable thumbnail aspect ratio.
* Fixed various lay-out issues for theme twentytwenty.
* When a CDN is active and the thumbnail ratio is not set to the default, the thumbnail iamges will now be used reather than the cdn smaller images.

= 7.2.13 =

* Changed algorithm and texts around 'Awaiting moderaion' for cxomments to more descriptive ones.
* Only mailintypes 'newalbumnotify', 'feuploadnotify', 'commentnotify' are now skipped for admin if Table IX-M97 is ticked.
* Added classes to the album navigator widget to enable css customization.
* The creation of .htacces file for photo permalinks is now always triggered on album creation.
* The numbers of photos in the titles in the tagcloud were not alwais correct on large systems. Fixed.
* Rating change did no longer work, a new rating was added. Fixed.

= 7.2.12 =

* Fixed a warning in the TopTen widget.
* When Comment needs rating (Table IV-F13) was active and the comment was given before the rating,
the comment moderate request mailing was sent instead of the comment notify mailing.
The comment notify issue is fixed. If configured, the comment moderate mailing will still be sent if the rating is not done in 120 seconds.
* Typing the keys ESC, x or q should exit lightbox. This stopped working. Fixed.
* Fixed a redundant " in the searchbox.
* The smileypicker could no longer be switched off. Fixed.
* New setting: Table IX-M97: No admin email. Do not send emails on adminbistrator actions.
If ticked, administrators can add albums, photos and comments without emails being sent.
* Added an exception for 'Comment needs rating': The user can add comments to his own photos (e.g. as a reply) without the need of a rating.
In this case the default moderation rules apply.
* Changed warning text when a rating is pending.
* When the user can not rate its own photos, the rating stars and thumbs will no longer be displayed on those photos.
The message 'Sorry ... ' on lightbox ia also removed.

= 7.2.11 =

* Fixed a few missing values in adding new rows to db tables to fix issues with certain sql implementations.
* Improved lay-out of commentform, especially for mobile devices.
* Ratings are now saved with the displayname as opposed to login name,
to make sure that rating needs comment and comment needs rating will work in all situations.
If comment needs vote or vote needs comment are active during upgrade,
all pending comments will be approved and all pending votes will be published.
* New shortcode attributes for type="calendar" calendar="real...: year="2013" month="10" for starting at october 2013.

= 7.2.10 =

* When the status of a photo is set to 'featured' it will be inserted in the standard wp media library,
now also works for mp4 videos.
* On the Moderate Photos admin page when there are no photos to moderate,
the page displayes all photos in the system by timestamp desc for administrators.
In this case the pagelinks were missing. Fixed.
* New shorcode attribute values for type="calendar". The new values are 'realtimestamp', 'realmodified' and 'realexifdtm' for the attribute calendar="",
so you can now have a 'real look' calendar using shortcode: [wppa type="calendar" calendar="realexifdtm"], optionally add the album="" attribute.
Note: Only numeric albums or numeric album enumerations are supported. E.g. album="7" or album="1.5..8.19", meaning albums 1,5,6,7,8 and 19.
* New setting: Table VI-C12: Real calendar link. May be lightbox (default) or slideshow. The slideshow will be dispalyed below the calendar.
* New shortcode argument for all calendar types: parent="x" where x is a single album id. When using parent="" it overrules the album="" argument.
* New option switch Table IV-F13: Comment needs vote. If ticked, a user must give a rating to get his comment published.
Note: This feature overrules other comment moderation settings.
* Fixed a js error in masonry horizontal thumbnails display on initial load.
* Fixed a bug in random photo order.

= 7.2.09 =

* Gutenberg preview of wppa gallery shorcodes now also works when Table IX-A1.3 is ticked.
* When uploading/importing an mp4 file, an attempt will be made to find the actual framesize,
the timestamp and the duration of the video. If found it will be registered.
* New maintenance proc Table VIII-B22: Fix mp4 meta data, to fix the metadata for the existing items.
* When the status of a photo is set to 'featured' it will be inserted in the standard wp media library,
so it can be used as featured image in a page/post. Changing the status threafter has no effect.
* Calendar vieuw with all open did no longer work. Fixed.

= 7.2.08 =

* Fixed a problem when displaying slideshows with comment field caused by user display names containing (single) quotes.
* Fixed a regression in the interpretation of shortcode arguments since 7.2.07 with respect to accented letters.
* Placeholder code for search box produced an error in certain circumstances. Fixed.
* Added plugin AMP to the blacklist, because it completely destroys the dynamic functionality (links, onclick event handlers etc).

= 7.2.07 =

* Various security and code quality issues fixed.
* Table IX-E22: Placeholder text for the search photos box/widget is believed to work in all configurations now.
* The zipfile name of the album download is now always sanitized and no longer dependant of Table IX-D17.
This fixes possible 404 errors on album downloads when the album name had funny characters like " in its name.
* One could not have more than one multitag/tags-filter instance on a page. Fixed.
* Fixed typo's and missig translations in the settings admin page.

= 7.2.06 =

* Fixed a few issues with user display names with accented characters.
* New setting: Table IX-E22: Placeholder text for the search photos box/widget.
* Various security and code quality issues fixed.

= 7.2.05 =

* Various minor security issues fixed.
* Layout fix for window resizing photo editor with imagemagick.
* Magick editing updated photo sizes with thumbnail sizes (on screen only). Fixed.
* Cropper did not show up when lazy load was active. Fixed.
* New Setting: Table IV-D9: Use thumb on cover. To use possible cropped thumbnail image on album covers even when a CDN is active.

= 7.2.04 =

* Adding tags by seleciting existing tags resulted in the text: [object HTMLTextAreaElement]. Fixed.
* Same for description when using wp editor. Fixed.
* Fixed a display issue in the supersearch box when js deferred.
* New setting: Table I-D9: Cover spacing. Sets the spacing size between multicolumn covers on a row. Does not work for 'Grid' covers.
* Fixed a typo in the topten widget activation screen.
* Breadcrumb can now be displayed when cover type is grid.
* Cropping now also works on the classic front-end editor when imagemagick is activated.

= 7.2.03 =

* Added crop functionality to imageMagick commands on the photo admin pages.
* Changed the algorithm for extended duplicate removal in search operations.
* Added a checkbox on the photo admin page to lock the thumbnail, so, if ticked,
the thumbnail file will not be remade when requested individually or in bulk procedures.
* Simplified (speeded up) and improved security while updating on the photo admin page.
* Improved reloading photo images after being visually modified on the photo admin page (without reloading the entire page).
* Fixed a spourious issue where the album timestamp was empty, causing php warnings.
* Any attempt to show previous or next on a lightbox single image showed the loading spinner. Fixed.

= 7.2.02 =

* Added cover type Grid with images only.
* Added Table IV-G2.2: Click om image, to browse on image click.
* Entering a path to imagick commands always returned an errormessage, even when the path was correct. Fixed.

= 7.2.01 =

* Changed the algoritm of the extended duplicate removal of search operations.
* Viewcounts were not bumped by lightbox if hires files were used for lightbox (Table IV-G6) or local CDN is active (Table IX-K4). Fixed.
* On large systems, the update of the value returned by w#fsviews took too long to be usefull.
It will now be updated immediately when update is pending and the value is requested.
* Added photo description keyword w#albumdesc to display the album description inside the photo description.
* If the url of a thumbnail is requested and the thumbnai file does not exist, an attempt to create it will be mane.
* Navigation icon size for lightbox is now configurable in Table I-J5.

= 7.2.00 =

* Changed defaults for Table IX-D19 and IX-D20 as this seems to be the most convenient.
* The mailing of frontload upload notifications will now combine multiple photos in one notification email for photos that have the same owner and are in the same album,
and the uploads have been done during a period of max 5 minutes.
* For users who can create (sub) albums, the uplaod widget and the box created by [wppa type="upload"] will now show a selectionbox of parents where the user can create a subalbum.
The selectionbox may contain --- none --- and --- separate --- if the user can create toplevel albums.
* The number of downloads as enabled in Table VI-C1.x is now registered.
* Added w#dlcount as photo description keyword to display the download count.
* Added display and sort method 'Download count' to the TopTen widget.
* For lightbox, multiple single images will now be treated as a set, so you can browse through them.
There will be separate sets for the three single image types 'photo', 'mphoto' and 'xphoto'.
* Fixed some ssl issues.

= 7.1.11 =

* Added a dummy row to the masonry horizontal thumbnail display to enable custom css to fix specific pluging conflicts.
The row can be accessed for css by: .wppa-masonry .dummy {}
* Removed '[/wppa]' and 'Any comment[/wppa]' form all helptexts and auto generated shortcodes, because we no longer use the long form of shortcodes.
Please be aware that you can still use long forms, but do never mix long and short forms together in any post or page.
* Slideonly and slideonlyf will now always wrap around, even when Table IV-B8 is unticked.
* Fixed a potential problem with local cdn filnames resulting in errors on the photo admin page. Local cdn files are now always rounded to integer x and y sizes.
* Added Table IX-E21 to remove items in search results wher name, description and displayfiles are identical.

= 7.1.10 =

* Failed attempts to create a directory tree will no longer result in a blank screen.
* Added a selection option to the photo of the day subtitle. Displays photo and album names and descriptions.
* Added 'non-zero only' checkbox in Table I-F1, to select only rated/viewed photos in the topten selection.
* Fixed a possible sql error in the topten widget.
* Fixed a problem when importing remote .png images.

= 7.1.09 =

* Dropped te use of WP_Filesystem() due to problems like installations where $wp_filesystem->is_dir() always returns false without a valid reason.
* Added Table IX-D20 to remove accents in filenames (prior to possible fully sanitizing), to fix the problem that wp sanitize_filename() simply removes the accented chars.
* Filenames are now changed to utf8 if they are not utf8 encoded.
* Fixed a problem with lightbox where the wrong item showed up as first when there were identical stub images present in the set.

= 7.1.08 =

* Fixed a bug that caused a fatal error when deleting a local cdn folder.
* When creating a sibling album, the following items are copied from the originating album: cover_type, cover_linktype, coverphoto if it is a method rather than an individual photo.
* Maintenance proc Table VIII-B21 added: Covert png to jpg.
* Max execution time (Table IX-A5) can not be lower than 25.
* Thumbnail files of multimedia items could not be remade. Fixed.
* Fixed a js issue in the fe upload procedure causing broken slideshows.

= 7.1.07 =

* Added Table IX-D19: Sanitize filenames during import/upload. Do not switch this off unless you really need this.
* Added a checkbox on the Import screen to remove empty dirs after dir to album imports.
* Improved reliability of remote imports.
* Session data is now also maintained for using admin pages.
* Added cover_linktype to acceptable items in wppa_update_album().

= 7.1.06 =

* Added shortcode argument delay="yes" to fill the wppa container by ajax after document.ready.
Use it when you have a random photo order and html caching. Does NOT work when defer javascript is active (Table IV-A13).
* Page specific js data is now printed in the page itsself, no longer by loading a page specific script file.
This saves a http request, and the page dependant data has to be loaded anyway.
* Fixed a layout issue in multicolumn responsive covers display.
* Videos did not display in the wppa recent activity dashboard widget. Fixed.
* Added 'infifite' as selection option in Table IX-A15.1
* Fixed a spurious warning message above wppa displays.

= 7.1.05 =

* Various security fixes.
* Additinal lazy load process during resize handler.
* Fixed a few 'undefined var' warnings.
* Comment request mderation emails were not sent when comment notify emails was disabled. Fixed.
* Unused depot folders will now automatically be deleted.
* User depot dirs will now be created the moment the user opens the import admin page for the first time.

= 7.1.04 =

* If a video has a posterimage and corresponding thumbnail, the thumbnail image will now be used as poster image for the album cover image.
* Added options to Table IX-A15.1 and Table IX-A15.2.
* Fixed possible hang during setup.
* The depot dir is now only created for the administrators and for other users that access the import page.

= 7.1.03 =

* Fixed layout of popup windows of Table VIII-C.
* Popup windows of Table VIII-C now use nicescroller.
* Version is now bumped for photo and thumbnail files after updating pdf poster image.
* Built-in protection against recursive error logging.
* Attempt to log recursive is detected and shown at the top of the log in Table VIII-A1 and on the adminbar menu loglist.
* Fixed a problem with frontend uploads when saving source was switched off.
* Fixed a problem with import pdf posters when saving source was switched off.

= 7.1.02 =

* Added Table IX-A16: Load nicescroller js always.
* Table I-C10 (Thumbnail area max size) and Table I-C11 (Use nicescroller) have been moved to Table I-A12 and Table I-A13 and apply now also to the album cover area.
* The local cdn file list on the photo admin page now link to the images in a new window.
* Fixed a filesystem credentials issue resulting in black local cdn images on certain servers.
* Added 'week number is order#' as choice in the Photo of the day admin page at line 11a.

= 7.1.01 =

* Pdfs now show the real pdfs in ”fs file with download and print buttons” popup window.
* You can have a CDN active when PDFs are enabled. However, the documents will stay stored locally on the server.
* Table IX-A15.1 and 15.2 added. Use in complex situations where window resizing partially fails.
* Multimedia icons are now custom uploadable. See Table II-J14.x. Note that changing the size here also changes the size of the medals on the thumbnail.
* Added Table IX-F13 and Table IX-F14 to specify size and margin of the watermark placement.

= 7.1.00 =

* The Photo Albums -> Upload Photos admin page now has only one box to upload all configured filetypes.
The sequence order of video/audio/pdf files and their respective poster files is no longer important,
so you can add an image to a mediafile as well as add a mediafile to an image,
provided the filenames except extensions are identical.
If you upload a zipfile with a directory structure,
this structure will be created as a sub-album structure if it does not already exist, and the items will be placed in the sub(sub) albums accordingly.
You may even upload zipfiles with embedded zipfiles.
* The Photo Albums -> Import Photos admin page now also supports document files of type pdf.
The sequence order of importing documents and poster image files is not important.
* The audio stub file was overwritten by the most recently uploaded audio posterfile. Fixed.
* Fixed a situation where the THREE.js file was erroneously not loaded, e.g. when going with ajax to a 360 display from a page without 360 images.
* When the available display space for thumbnails was smaller than the thumbnail size, the thumbnail was displayed off the screen. Fixed.
* The 'Default photo name' method as selected in Table IX-D13 is now also applied when importing photos etc.
* Lightbox on pdf thumbnail images opens the pdf itsself in an iframe on non-mobile equipment.
* Pdfs in slideshows display the actual pdfs.
* Pdfs in single image types display the actual pdfs.

= 7.0.12 =

* Update addressline with pretty urls issued a problem on the homepage. Fixed.
* Fixed a problem where non admin users tried to delete their own album.
* Fixed an issue with respect to the parent album selection box.
* Treecounts were not updated after a pdf upload. Fixed.
* Added name slugs on the album and photo admin pages. These names will be used in urls, if names in urls configured.

= 7.0.11 =

* Fixed a js warning related to google maps api loading.
* Fixed a compatibility issue with wp search.
* Uploads of pdfs in Box A and Box B work correctly now.

= 7.0.10 =

* Album and photo name slugs were not always updated on name change. Fixed.
* Hughe performance improvement for mailing commentnotify.

= 7.0.09 =

* Added a checkbox to the album widget to include (great)(grand)children.
* Cosmetic changes to the settings page Table VIII buttons.
* Thumbnail popups now stay within the thumbnail area.
* QR cache did not work. Fixed.
* The logfile is now displayed with the youngest message first.
* Local cdn did not generate .png images. Fixed.
* Status stars on the settings page for changing iptc and exif items did not show busy/ready/error icons. Fixed.
* Scrolling on panoramas to zoom in/out will no longer move the pagecontent up/down.
* Table IX-M3: Mail on comment, now has a checkbox to limit the mailing to photo owner and admin only.

= 7.0.08 =

* Added dashboard widget for (un)subscribing to/from mailinglists.
* Remake failed on .pdf's. Fixed.
* Links defined on the photo of the day admin page did not work. Fixed.
* Available tags were not updated when a photo was deleted. Fixed.
* Auto updates could fail due to improper initialisation of wp filesystem. Fixed.
* On certain systems uploads were no longer possible due to improper initialisation of wp filesystem. Fixed.
* Copy/move photos generated a comm error. Fixed.

= 7.0.07 =

* Security fixes
* Added class wppa-notify-check to checkboxes and wppa-notify-label to labels on the frontend of the notify widget.

= 7.0.06 =

* Fixed textual issues on the settings admin page.
* Fixed defined path errors for Windows multisite individual systems.
* Fixed nicescroll on window with deferred javascript.
* Long mailinglists no longer break at timeout.

= 7.0.05 =

* Fixed an issue with random sequence order when the content (thumbnails) is paginated.
* Improved responsiveness to fix certain compatibility issues.
* New photo name (Table IX-D13) now also works on backend uploads and imports.
* Certain actions on album admin and photo admin did no longer work. Fixed.
* Added Table IV-A34: Response speed. Select: The speed of responsive size adjustments.

= 7.0.04 =

= Bug Fixes =

* Fixed a problem in commenting.
* Fixed a problem in changing photo information.
* Fixed a problem in comment status.

= Other Changes =

* Added error messages on the admin dashboard in case of certain configuration conflicts.

= 7.0.03 =

= Bug Fixes =

* Mail previous commented did not work. Fixed. ("SELECT DISTINCT")
* Local selection box in import page was empty. Fixed. (wp-content is a safe path in import glob)

= New Features =

* Indicators on thumbnails of media items when no control bar is present and on pdf document thumbnails.
* If you have no ImageMagick installed or your ImageMagick version does not convert .pdf to .jpg, you can now upload a self created image file (e.g. screenshot) after the upload of the .pdf file.
Names must be equal except the file-extension. .jpg and .png files are supported for this purpose.
* Direct rating and commenting. See Table IX-A14.

= 7.0.02 =

= Bug Fixes =

* Fix for WPPA_MULTISITE_BLOGSDIR (WPPA_CONTENT_PATH . '/blogs.dir' is now a safe path)

= Other Changes =

* Various security fixes

= 7.0.01 =

= Bug Fixes =

* Front-end uploaddialog: when admin, multiple uploads should be possible even when one only was activated. Fixed. ($one_only = wppa_switch( 'upload_one_only' ) && ! wppa_user_is( 'administrator' );)
* Front-end uploaddialog: very long filenames distorted layout. Fixed. (onclick="wppaSetMaxWidthToParentWidth(this);" on the visual button)
* Link on thumbnail to lightbox did not work when the photo has audio. Fixed. (wppa_fix_poster_ext() now also works on versioned urls)
* Automatic cache clearing stopped working, fixed. (WPPA_UPLOAD_PATH . '/cache' is now a safe root)

= Other Changes =

* Table IV-A6: Enable pretty links - is now a selectionbox with three options: none, classic, and compressed.
Compressed makes a bit better human readable urls when using album and photonames in urls is activated.
* Compatibility with WPGlobus as alternative to qTranslate.

= 7.0.00 =

= Bug Fixes =

* [wppa type="slphoto" photo="#last"] did not work. Fixed.

= New Features =

* Shortcode generators for Gutenberg added.
* New widget: WPPA+ Notify. Users can subscribe/unsubscribe for various mailings. Configure availability of mailing types in Table IX-M.

= Other Changes =

* Removed Table IX-A14. Frontend code is now always loaded.
* Removed script to shortcode conversion warning and tool.
* The shortcode generators now produce self-closing shortcodes, i.e. without [/wppa].
* Removed Table IV-F5. Configure emailing in Table IX-M.
* Album selectionlist in upload widget is now always sorted alphabetically.

= 6.9.21 =

= Bug Fixes =

* Album owner could no longer be set to --- public ---. Fixed.

= Other Changes =

* Added 'pointer' to the selectable lightbox cursors in Table I-G2.

= 6.9.20 =

= Bug Fixes =

* Fixed erroneously reported unsafe filepaths found and hence inability to upload/import in certain configurations.
* WPPA logging will no longer generate errormessages.
* Fixed db prefix issue for multisite global installations, resulting in a.o. inability to edit album and photo information.

= 6.9.19 =

= Bug Fixes =

* Fixed erroneously reported unsafe filepaths found and hence inability to upload/import in certain configurations.

= 6.9.18 =

= Bug Fixes =

* Fixed erroneously reported unsafe filepaths found and hence inability to upload/import on new installations.

= 6.9.17 =

= Bug Fixes =

* Fixed a layout issue of the album description field on the album admin edit album information screen.
* Custom data fields disappeared in 6.9.16 when php version < 7.0. Fixed.

= 6.9.16 =

= Other Changes =

* Increased number of options in Table IX-B6.1 and Table IX-B6.: Album and Photo admin pagesize.
* Added 'Filename without extension, spaces for hyphens' as option to Table IX-D13.
* Added maintenance proc Table VIII-B20: Remove all hyphens from all photo names and replace them by spaces.
* Imported photos now get the name as defined by the new name method in Table VIII-B20.
* Various security fixes.

= 6.9.15 =

= Other Changes =

* When ImageMagick is active and filename as default photoname has been defined:
Uploading files with spaces and brackets in the name will have their photonames correctly derived from the original filename.
The filename as saved in the database and on disk will be sanitized.
This does not apply to photo imports, because their names are always sanitized before processing.

* Various security fixes.

= 6.9.14 =

= Other Changes =

* Added Table IX-A14: Load front-end code always.
* Various security fixes.

= 6.9.13 =

= Bug Fixes =

* Trying to import a non existing remote photo no longer generates a warning in the server log.

= Other Changes =

* Several security issues found by RIPS Technologies (https://www.ripstech.com)
* If ImageMagick is activated, all filenames of newly uploaded or imported files will be sanitized by sanitize_file_name().
This implies (a.o.) that spaces in filenames will be converted to dashes. Due to security reasons this is a permanent restriction.

= 6.9.12 =

= Bug Fixes =

* Fixed a layout issue on the settings page.
* Fixed a layout issue on lightbox spheric panoramas that occurs when there are also normal photos in the set.
* Fixed uninitialized vars in widget activation screens.

= Other Changes =

* One can select 'none' in Table IV-H1: Panorama control bar.
* A smaller subset of THREE.js is now loaded, and it is only loaded when needed, provided that you have set defer javascript in Table IV-A13 (is the default).
* Panorama code is now also available at the backend edit screen if applicable.

= 6.9.11 =

= Bug Fixes =

* Performance improvement on panoramas on lightbox. A.o.: the wrong image was pre-loaded. Fixed.

= New Features =

* Additional panorama settings. See Table IV-H.
* Zoom by the mousewheel on panoramas.

= 6.9.10 =

= Bug Fixes =

* Lightbox on a single image did no longer work on images that are not a panorama. Fixed.

= Other Changes =

* Increase stability, improved performance and reduced codesize for panoramas.

= 6.9.09 =

= New Features =

* Panorama images phase III: Lightbox supports panoramic images.

= 6.9.08 =

= Bug Fixes =

* When lightbox global was the only wppa activity on the page and javascript deferred, lightbox did not work. Fixed.

= New Features =

* Panorama images phase II: Non 360 flat panorama photos can be displayed as any of the three single image types.

= 6.9.07 =

= Bug Fixes =

* Fixed alignment of slide navigation icons 48px.
* Removed erroneous warning during upload when local cdn is enabled.

= New Features =

* Panorama images phase I: 360 deg spherical panorama photos can be displayed as any of the three single image types.
Tick Table IV-A24.2 and a selectionbox will appear on the photo admin page at every photo.

= Other Changes =

* Added Table IX-L7.1: Render photo once. Replace shortcode by html. Use only if you need this for other plugins purposes.

= 6.9.06 =

= Bug Fixes =

* One button vote did not work properly. Fixed.
* Fixed a bug in updating addressline in slideshows.

= Other Changes =

* Navigation and rating icon sizes can now be set in Table I-J.
* The display of the wppa activity dashboard widget can not be specified in Table II-J13.

= 6.9.05 =

= Bug Fixes =

* Uploading by shortcode withut album spec succeeded but resulted in a blank page. Fixed.
* Sub album cover links to empty albums caused division by zero errors. Fixed.

= New Features =

* Table I-C10: Thumbnail area max size. A number > 1 means pixels, a number < 1 means a fraction of the viewport height.
* Table I-C11: Use nicescroller. Use nicescroller on thumbnail area that has been limited in size due to Table I-C10.
* Table IV-A32: Nice scroll on window. Use nicescroller on the window.
* Table IV-A33: Nice scroll configuration options

= Other Changes =

* Admin will no longer receive notification emails reporting his own comments.

= 6.9.04 =

= Bug Fixes =

* On slideshow: Ugly browse buttons now vanish after 3 seconds, as designed.
* Tagcloud and Multitags widget displayed untranslated (qTranslate-x) tags. Fixed.

= New Features =

* In Table IX-K4 one can now select 'Local'. This enables a local CDN functionality.
All images are loaded at the reduced size they will be shown.
Note that the first time you show a thumbnail or any other sized image, it take some extra time to create it.
Sized image creation works both with standard GD and also with external Imagick commands (See Table IX-K7), which is much faster.

= Other Changes =

* Added handler onscroll="wppaMakeLazyVisible();" to thumbnail area. This enables the use of custom css

.wppa-thumb-area {
	max-height:500px;
	overflow:auto;
}

while Lazy Loading is activated.

= 6.9.03 =

= Bug Fixes =

* Cloudinary now works for all types of photo displays.
* Slideshows did no longer work when the photo name has ' in the name. Fixed.

= New Features =

* Table IV-A19: Lazy Load. If ticked: All photos are now lazy-loaded.
They will load at the moment they are or tend to appear inside the browser window.
This causes a substantial performance improvement and allows a.o. for very large page sizes for thumbnails and filmstrips i.e. slideshows.

= 6.9.02 =

= Bug Fixes =

* Fixed aspect ratio of images in comment admin.
* Usernames apeared at photos rather than display names. Fixed.
* If no download link specified and Domain links BuddyPress was active, a pseudocode was shown instead of the domain link under the slideshow. Fixed.

= New Features =

* New shortcode [wppa_div][/wppa_div]. Places a div. Attributes: style="" and class="". Default: style="clear:both;position:relative;"
* Selectable spinner image. Works only with svg (Table II-J12).

= 6.9.01 =

= Bug Fixes =

* Links to plain photo on sideshow did not work since 6.9.00. Fixed.

= New Features =

* Table IX-J10: Domain links BuddyPress. Converts usernames in extended photo names and as converted from w#owner to domain links in Buddypress.

= Other Changes =

* Improved layout of the Export user data file.
* Table VII-D3 and 4 are now combined into VII-D3: Upload memory check.
* Table VII-D4 is now: Upload memory check copy.
If a photo is too large in pixelsize to be downsized due to memory limitation, it will be copied rather than resized.
This will also result in having large thumbnails!
It is recommended to have the two settings checked.
Front-end upload photo sizes can only be limited by Table VII-B10.x. If VII-D3 or VII-D4 are UNchecked, you may expect out of memory errors.

= 6.9.00 =

= Bug Fixes =

* Fixed wrong text in statistics widget activation screen.

= New Features =

* Added required code for the Privacy Policy procedures.

= 6.8.09 =

= Bug Fixes =

* If lightbox global was active and no wppa images on the page, lightbox did not work. Fixed.
* Import page: No import button when only .csv files were present. Fixed.

= New Features =

* Breadcrumb, Table II-A4.4: Photo name: Show name of photo above slideshow. You can now switch it off.
* GPX maps, Table IX-K5.4: Zoomlevel: The starting zoomlevel for the embedded GPX implementation.

= Other Changes =

* Removed obsolete and not used code, obsolete comments and diagnostics.

= 6.8.08 =

= Bug Fixes =

* The initial display of the fullscreen lightbox on Firefox was incorrect. Fixed.
* Changing orientation of mobile devices gave wrong initial display of the fullscreen lightbox. Fixed.
* Interactive maintenance procedures stopped at server errors. Fixed. After 10 server errors there is a confirmationbox asking to continue or not.
* If a source image file does not exist, a backup of the displayfile int the source folder will be made prior to making an image edit with imagick.
This enables the undo function for photos that did not have its source file present.
* (Un)ticking Table I-D5, Table II-J9 and J10 did not work. Fixed.
* Fixed a layout issue in the album navigator widget.
* Fixed a lightbox issue resulting in displaying the plain image when the link was clicked before the lightbox was fully initialized.

= New Features =

* Added Table IV-A31: No rightclick. Disable right mouseclick on all images.

= Other Changes =

* When using Autoptimize, one can now optimize js with it, it will no longer conflict with wppa.
You can also optimize html with Autoptimize and remove html comments without affecting the filmstrip speed or functionality.
* When Defer Javascript is switched on (Table IV-A13), no wppa script files will be loaded if there is no wppa activity on the page. This is now the default.
* Removed obsolete settings Table IV-A19: Lazy or HTML comp; Table IV-A29: JS and CSS when needed.
* On the Import page: changing local/remote or the source folder will no longer need a buttonclick; the page will reload automatically.

= 6.8.07 =

= Bug Fixes =

* Fixed an error when timezone was set to an UTC offset rather than a city.
* Some settings caused js errors and did not work correctily. Fixed.

= New Features =

* New widget: Statistics.

= Other Changes =

* All widgets have a checkbox to restrict the display to logged-in visitors only.

= 6.8.06 =

= Bug Fixes =

* Clicking the help button [?] on the settings page now always opens the right helptext.

= New Features =

= Other Changes =

* A photo is now regarded as NOT being modified when the date/time modified is within 2 seconds after the timestamp of creation.
This is to avoid erroneous 'modified' labels due to photo metatdata updates during the upload/import process.
* Only cached pages that contain wppa data are cleared by wppa clear cache. Cache clearing is now performed at the background.

= 6.8.05 =

= Bug Fixes =

* LasTen widget showed deleted photos until they were actually removed from the system. Fixed.

= New Features =

* Table IV-F12: Comment db agreement. Places a checkbox on the commentform to agree that the information will be stored in a db.
* Lightbox global (see Table IV-G5) now also works upon images in wpForo forums.

= Other Changes =

* Lightbox global now shows the title and the caption of the wp image as subtext on the lightbox display.
* Photo owners now have the right to remove their own photos if Table VII-D2.7 is ticked;
they do no longer need the right to edit photo information to be able to delete.
* You can set a maximum time for frontend edit in Table VII-D2.2.1 and for frontend delete in Table VII-D2.8

= 6.8.04 =

= Bug Fixes =

* Album navigator widget: fixed a layout issue for themes that have a background image on list items.
* Under some circumstances 'Granted albums' were created, while there was no valid parent(s) specification.
* Table IV-G3.1 initially shows ---none--- but is in fact 300ms. Fixed.

= New Features =

* Table VIII-13.1 and Table VIII-14.1 to schedule the regeneration of crypto codes on a regular basis.

= Other Changes =

* Bestof images in the box-version are now displayed like default thumbnails so the horizontal placement now behaves responsive.
The height shortcode attribute is now treated as the maximum for the width and the height.
* Corrected and enhanced the explanationbox on the Photo Albums -> Upload Photos admin page.
* Improved lightbox performance (speed).
* Added a few locations where the cache will be cleared.

= 6.8.03 =

= Bug Fixes =

* Due to a left-over from testing, switching to flat album table did no longer work. Fixed.
* On the album admin page: if the album is full, two - inactive - upload/import buttons were displayed. Fixed.
* On the photo admin screen: the caption of the exif table was not translatable. Fixed.

= New Features =

* You can keep a history log of the photo of the day. See the photo of the day admin page. It will show up at the admin dashboard.

= Other Changes =

* If the default photo description (Table IX-D5) contains HTML code, it will no longer be shown on the frontend upload dialog.
* Wppa will no longer crash the sites admin at activation time when the PHP EXIF functions are not activated.

= 6.8.02 =

= Bug Fixes =

* Sourcefiles got erroneoulsy removed in certain circumstances.
This happened when there were two or more photos with the same name in an album and one got deleted.
This also happened when a photo was deleted and re-uploaded before the background process actually removed the files of the deleted photo.
This issue has been fixed.
* w#hrurl and w#pl in photo descriptions got wrong results when the filename contained spaces or brackets. Fixed.
* Fixes for compatibility with plugin Simple Cart & By Now. This plugin is not maintained for over three years.
If you update to wppa version 6.8.02 and use SCABN, you MUST install the special - fixed - version to maintain compatibility.

= New Features =

* Table VII-B4: Fe limts per album. If this box is ticked, the upload limits set for userroles apply to each album individually where the user has frontend oploads to.
* You can now add browser specific css. Table IV-A15.x.
* If the user has the right to import, there is a button on the album admin screen to import to the album, like the upload to this album button.
* Added links to upload and import pages on the album admin main page, dependant of user rights.

= Other Changes =

* On most installations you will no longer see failed uploads due to memory limitations.
When there is not enough memory to downsize photos or to apply watermarks, downsizing will be skipped.
Note that in those cases one can have copies of the original photofiles as thumbnail images.
If this happens often, it is rcommended to set an upload size limit in Table VII-B10.2 to force users to upload smaller images,
or to ask the hosting provider to increase the available sever memory.
* Created a fixed version of plugin Simple Cart & Buy Now. You will need this special version if you previously used Simple Cart & Buy Now in combination with wppa.
Download it <a href="https://wppa.nl/wp-content/uploads/simple-cart-buy-now-for-wppa.zip" >here</a>

= 6.8.01 =

= Bug Fixes =

* Fixed layout issues of the album navigator widget and the album / photo admin pages.

= New Features =

* GPS and File tags are now supported in the exif system.

= Other Changes =

* Added to the bestof widget: A checkbox to display the sum of the ratings (totvalue), and the option to sort by the sum of the ratings.
* Bestof shortcode now also supports the display of the sum of the ratings (totvalue="yes"), and the sort option to sort by the sum of the ratings (sortby="totvalue").
The full shortcode is now: [wppa type="bestof" page="nn" count="nn" display="photo|owner" period="thisweek|lastweek|lastmonth|thismonth|lastyear|thisyear" sortby="maxratingcount|meanrating|ratingcount|totvalue" maxratings="yes|no" meanrat="yes|no" ratcount="yes|no" totvalue="no|yes" linktype="none|owneralbums|ownerphotos|upldrphotos" fontsize="nn" lineheight="nn" height="nn"][/wppa]
Note: For backward compatibility: the default for displaying the total value is no (totvalue="no") as opposed to the other display options.
* Exif arrays are now stored as arrays as opposed to multiple items with the same tag id. This enables interpretation and formatting of array value tags.
* Improved display of help text in settings and photo of the day settings admin pages.
* Removed obsolete browser specific css.
* Improved layout and behaviour of frontend upload dialog.

= 6.8.00 =

= Bug Fixes =

* Various minor fixes for PHP 7.2 compatibility.
* If the visitor does not have the rights to edit a photo at the front-end, there will not be a link or button to the edit page.
* On the Import and Upload Photos admin pages one can now select a target album even when there are more albums than the setting in Table IX-B6.3.
* The most recently uploaded photo had its viewcount bumped for every session when the [photo] shortcode was enabled. Fixed.
* If you use qr codes and cache them (See Table IX-K1.4), the cache will be cleared regularly to prvent the generation of too many files.

= New Features =

* On the Album Admin -> Edit screen: the photo information now also shows the EXIF data, if available.
* Shortcode [photo xxx] can now have 'random' as argument, e.g.: [photo random]. See Table IX-L for details.
* On the shortcode generator, one can optionally select one or more albums for the upload box.

= Other Changes =

* Supersearch. Selection boxes are now sorted, exif values are formatted.
Certain camera brand specific tags are now recognized and (partially) correct formatted.
* Further improved formatting of various exif tags.

= For more information about older versions: see https://wppa.nl/changelog/
